<!DOCTYPE html>
<html lang="es">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Capitulo_3</title>
</head>
<body>
    <h1>Capitulo 3</h1>
    <a>Ejercicio 1</a>

    <script>

    class Pila {
        constructor() {
            this.pila1 = [];
            this.pila2 = [];
            this.pila3 = [];
        }

        push(element) {
            let tam1 = pila.size1(),
                tam2 = pila.size2(),
                tam3 = pila.size3();
            if (tam1 < 5) {
                this.pila1.push(element);
                return this.pila1;
            } else if (tam2 < 5) {
                console.log(`La Pila 1 esta llena, el elemento ${element} se añadira a la Pila 2`);
                this.pila2.push(element);
                return this.pila2;
            } else if (tam3 < 5) {
                console.log(`La Pila 1 esta llena, el elemento ${element} se añadira a la Pila 3`);
                this.pila3.push(element);
                return this.pila3;
            } else {
                console.error(`Las Pilas estan llenas`);
            }
        }

        pop() {
            let tam1 = pila.size1(),
                tam2 = pila.size2(),
                tam3 = pila.size3();
            if (tam3 > 0) {
                return this.pila3.pop();
            } else if (tam2 > 0) {
                console.log("La pila 3 esta vacia, se esta haciendo un POP a la pila 2");
                return this.pila2.pop();
            } else if (tam1 > 0) {
                console.log("La pila 2 esta vacia, se esta haciendo un POP a la pila 1");
                return this.pila1.pop();
            } else {
                console.info("Ya no hay elementos en la pila")                
            }
        }

        size1() {
            return this.pila1.length;
        }

        size2() {
            return this.pila2.length;
        }

        size3() {
            return this.pila3.length;
        }

        print() {
            console.log(`---------------------`);
            console.log(`Pila 1: ${this.pila1}`);
            console.log(`Pila 2: ${this.pila2}`);
            console.log(`Pila 3: ${this.pila3}`);
            console.log(`---------------------`);
        }
    }


    let pila = new Pila();
    pila.push(8);
    pila.push(2);
    pila.push(2);
    pila.push(5);
    pila.push(6);
    pila.push(9);
    pila.push(1);
    pila.push(5);
    pila.push(3);
    pila.push(8);
    pila.push(1);
    pila.push(4);
    pila.push(7);
    pila.push(6);
    pila.push(10);+
    pila.push(8);
    pila.print();
    pila.pop();
    pila.pop();
    pila.pop();
    pila.pop();
    pila.pop();
    pila.pop();
    pila.pop();
    pila.pop();
    pila.pop();
    pila.pop();
    pila.pop();
    pila.pop();
    pila.pop();
    pila.pop();
    pila.pop();
    pila.pop();
    pila.print();




    



    </script>
    
</body>
</html>